window.Gleam.initSearch([{"doc":"css_select","title":"css_select","content":"# css_select\n\nLibary for parsing and matching simple CSS selectors against HTML elements.\nA simple selector is a selector that does not contain combinators like `&gt;`, `+`, `~`, ` `.\n\n(They might be added in the future).\n\n**This is lib is work in progress.**\n\n```gleam\nimport css_select\n\n\nlet assert Ok(selector) = css_select.parse_simple_selector(&quot;div#wibble.wobble&quot;)\nlet element = #(\n  &quot;div&quot;,\n  [\n    #(&quot;class&quot;, &quot;wobble wubble&quot;),\n    #(&quot;id&quot;, &quot;wibble&quot;)\n  ]\n)\n\ncss_select.simple_match(element, selector)  // True\n```\n\n## Supported selectors\n\n| Selector                       | Example                       | Description                                                                |\n| ------------------------------ | ----------------------------- | -------------------------------------------------------------------------- |\n| Type                           | `div`                         | Matches elements of the given type                                         |\n| ID                             | `#wibble`                     | Matches elements with the given ID                                         |\n| Class                          | `.wibble`                     | Matches elements with the given class                                      |\n| Psuedo-classes                 | `:checked`                    | Matches psuedo classes like `checked`, `disabled`, `selected`, `readonly`. |\n| Attribute                      | `[href]`                      | Matches elements with the given attribute                                  |\n| Attribute with value           | `[href=&quot;http://example.com&quot;]` | Matches elements with the given attribute and value prefix                 |\n| Attribute with value prefix    | `[href^=&quot;http://&quot;]`           | Matches elements with the given attribute and value suffix                 |\n| Attribute with value inclusion | `[href*=&quot;example&quot;]`           | Matches elements with the given attribute and includes the value           |\n\nThe matching is case senssitive and it does support complex psuedo classes like\nthat needs more than one element to work.\n\n## Development\n\n```sh\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"css_select/selector","title":"AttributeSelector","content":"pub type AttributeSelector {\n  Id(String)\n  Class(String)\n  AttributeExists(String)\n  AttributeEqual(String, String)\n  AttributePrefix(String, String)\n  AttributeSuffix(String, String)\n  AttributeIncludes(String, String)\n  Psuedo(String)\n}\n\nId(String)\n\n\nClass(String)\n\n\nAttributeExists(String)\n\n\nAttributeEqual(String, String)\n\n\nAttributePrefix(String, String)\n\n\nAttributeSuffix(String, String)\n\n\nAttributeIncludes(String, String)\n\n\nPsuedo(String)\n\n\nSynonyms:\ncss_select/selector.AttributeSelector\ncss_select/selector AttributeSelector","url":"css_select/selector.html#AttributeSelector"},{"doc":"css_select/selector","title":"Selector","content":"pub type Selector {\n  ElementSelector(TagSelector, List(AttributeSelector))\n}\n\nElementSelector(TagSelector, List(AttributeSelector))\n\n\nSynonyms:\ncss_select/selector.Selector\ncss_select/selector Selector","url":"css_select/selector.html#Selector"},{"doc":"css_select/selector","title":"TagSelector","content":"pub type TagSelector {\n  Any\n  Tag(String)\n}\n\nAny\n\n\nTag(String)\n\n\nSynonyms:\ncss_select/selector.TagSelector\ncss_select/selector TagSelector","url":"css_select/selector.html#TagSelector"},{"doc":"css_select/selector","title":"to_string","content":"pub fn to_string(selector: Selector) -&gt; String\n\nSynonyms:\ncss_select/selector.to_string\ncss_select/selector to_string","url":"css_select/selector.html#to_string"},{"doc":"css_select/selector","title":"css_select/selector","content":"","url":"css_select/selector.html"},{"doc":"css_select/simple_matcher","title":"Element","content":"pub type Element =\n  #(String, List(#(String, String)))\n\n\nSynonyms:\ncss_select/simple_matcher.Element\ncss_select/simple_matcher Element","url":"css_select/simple_matcher.html#Element"},{"doc":"css_select/simple_matcher","title":"match","content":"pub fn match(\n  element: #(String, List(#(String, String))),\n  selector: Selector,\n) -&gt; Bool\n\nSynonyms:\ncss_select/simple_matcher.match\ncss_select/simple_matcher match","url":"css_select/simple_matcher.html#match"},{"doc":"css_select/simple_matcher","title":"css_select/simple_matcher","content":"","url":"css_select/simple_matcher.html"},{"doc":"css_select","title":"parse_simple_selector","content":"pub const parse_simple_selector: fn(String) -&gt;\n  Result(Selector, ParseError(a))\n\nSynonyms:\ncss_select.parse_simple_selector\ncss_select parse_simple_selector","url":"css_select.html#parse_simple_selector"},{"doc":"css_select","title":"simple_match","content":"pub const simple_match: fn(\n  #(String, List(#(String, String))),\n  Selector,\n) -&gt; Bool\n\nSynonyms:\ncss_select.simple_match\ncss_select simple_match","url":"css_select.html#simple_match"},{"doc":"css_select","title":"css_select","content":"","url":"css_select.html"}]);